#ifndef __dmxoe_hh__
#define __dmxoe_hh__

#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>

#include "dmxoe_codec.h"

class DMXoESocket
{
private:
        char           connstat;
	int            sockfd;
        unsigned char *valueBuffer;
        int            maxSlots;
        unsigned char *netbuff;
        size_t         netbuffSize;

	char          *hostname;
	unsigned short hostport;

        int Init (size_t newSlots, char *newHname=NULL, unsigned short port=2501);
        int Connect ();
        int send_dmx (unsigned char *dmxbuf,  size_t numslots);

public:
	DMXoESocket (char *hname=NULL, int newSlots=512);
	DMXoESocket (int newSlots=512);
	~DMXoESocket ();

	char IsConnected ();

	int flush ();
	int flush (int slotCount, unsigned char *slotValues);

	int setSlotValue (int slot, int value);
	int getSlotValue (int slot, int value);
};


#endif
