#include <stdio.h>
#include <dmx/plugin.h>


int my_notify (dmxuniverse_t *u)
{
  if (u)
    {
      int i;
      int old=-1;
      int first=0;
      printf ("numslots=%d\n", u->numslots);
      for (i=0; i<u->numslots; i++)
        {
          if (u->buffer[first] != u->buffer[i] || i==(u->numslots-1))
            {
              if (first==(i-1))
                printf ("[%d]=%02X ", first, u->buffer[first]);
              else
                printf ("[%d..%d]=%02X ", first, i-1, u->buffer[first]);
              first=i;
            }
        }
      printf ("\n");
    }
  else
    printf ("my_notify: universe is NULL\n");
}



int main(int argc, char **argv)
{
  int rotator=0;
  char rotator_chars[4] = "|/-\\";

  if (argc > 1)
    {
      dmxplugin_t *p1 = loadPlugin (NULL, argv[1]);
      if (p1)
        {
          dmxuniverse_t u1;

          printf ("dmx-dump:\n");
#if 0
          for (y=0; y < (height-1)/2; y++)
            {
              for (x=0; x < width/3; x++)
                mvprintw (y*2+1,x, "%d", );
            }
#endif
          u1.notify = my_notify;
          if (p1->bind_universe (0, &u1) >= 0)
            {

            while (1)
              {
                sleep(1);
                printf ("\r sleeping %c\r", rotator_chars[rotator++]);
                rotator&=3;
                fflush(stdout);
              }

            p1->unbind_universe (0, &u1);
          }

          if (p1->delete)
            p1->delete (p1);
        }
      else
        printf ("  unable to load plugin\n");
      printf ("\n");
      sleep(2);
    }
  else
    printf ("dmxdump <plugin>\n");
  
  return 0;
}



